#!/bin/bash

#
# Copyright (C) 2021 University of Southern California.
# All rights reserved.                                            
#                                                                
# Redistribution and use in source and binary forms are permitted
# provided that the above copyright notice and this paragraph are
# duplicated in all such forms and that any documentation, advertising
# materials, and other materials related to such distribution and use
# acknowledge that the software was developed by the University of
# Southern California, Information Sciences Institute.  The name of the
# University may not be used to endorse or promote products derived from
# this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
# 

# read input produced by parse_geolitecity.pl and convert it to blocks

S=$(readlink -f $(dirname $0))

dbsort -n ip_low |
    dbcolcreate block IP IPhex |
    dbroweval '
              my $start_ip = _ip_low & 0xffffff00;
              if ((_ip_low & 0xff) != 0) {
                 _block = sprintf("%08x", _ip_low & 0xffffff00);
                 if (_last_block ne _block) {
                     _IP = sprintf("%d.%d.%d.%d", map(hex, _block =~ m[.{1,2}]g));
                     _IPhex = _block;
                     &$write_fastpath_sub($fref);
                 }
                 my $hlow = sprintf("%08x", _ip_low);
                 _IP = sprintf("%d.%d.%d.%d", map(hex, $hlow =~ m[.{1,2}]g));
                 _IPhex = sprintf("%08x", _ip_low);
                 &$write_fastpath_sub($fref);
                 $start_ip += 256; 
              }
              
              for (my $ip=$start_ip; $ip <= _ip_high; $ip+=256) { 
                  _block = sprintf("%08x", $ip);
                  _IP = sprintf("%d.%d.%d.%d", map(hex, _block =~ m[.{1,2}]g));
                  _IPhex = _block;
                  &$write_fastpath_sub($fref);
              }
              next row;' |
    dbsort block IPhex |
    dbcolcreate color |
    $S/lonlat2color.sh |
    dbcol block IP latitude longitude accuracy_radius country region city metro_code color

